﻿using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Windows;
using LINQtoAll.Properties;

namespace LINQtoAll
{
  /// <summary>
  /// Interaction logic for Window1.xaml
  /// </summary>
  public partial class Window1 : Window
  {
    public Window1()
    {
      InitializeComponent();
    }

    #region XML

    private void btnXMLSelect_Click(object sender, RoutedEventArgs e)
    {
      Workers workers = new Workers();
      List<string> xmlWorkers = workers.LoadXML();

      this.txtOutput.Clear();

      foreach (string worker in xmlWorkers)
        this.txtOutput.Text += worker + "\r\n";
    }

    private void btnXMLAdd_Click(object sender, RoutedEventArgs e)
    {
      Workers workers = new Workers();
      workers.AddIntoXML();
    }

    #endregion

    #region SQL 

    private void btnNorthWind_Click(object sender, RoutedEventArgs e)
    {
      //SelectSQLCustomersADO();
      SelectSQLCustomers();
    }

    private void btnStoredProc_Click(object sender, RoutedEventArgs e)
    {
      NorthwindDatabase dataContext = new NorthwindDatabase();

      this.txtOutput.Clear();
      var products = dataContext.Ten_Most_Expensive_Products();
      foreach (var product in products)
        this.txtOutput.Text += product.TenMostExpensiveProducts + "\r\n";
    }

    #endregion

    private void ForEachExample()
    {
      Workers workers = new Workers();
      List<Coworker> names = workers.GetNames();
      
      foreach (Coworker worker in names)
      {
        if (worker.Name.Contains("E"))
          this.txtOutput.Text += worker.Name + "\r\n";
      }
    }

    private void btnObjSelect_Click(object sender, RoutedEventArgs e)
    {
      //ForEachExample();

      Workers workers = new Workers();
      List<Coworker> names = workers.GetNames();
      
      this.txtOutput.Clear();
      foreach (Coworker worker in names)
      {
        this.txtOutput.Text += worker.Name + "\r\n";
      }

      var workerNames = names.Where(c => c.Name.Contains("E"));
      List<Coworker> workerList = workerNames.ToList();
      names.Add(new Coworker { Name = "sEibaba" });


      this.txtOutput.Text += "\r\nworkerNames\t" + workerNames.ToList().Count.ToString() + "\r\n";
      this.txtOutput.Text += "workerList\t" + workerList.Count.ToString();
    }

    #region SQL Examples

    /// <summary>
    /// Also works
    /// </summary>
    private void SelectSQLCustomersADO()
    {
      SqlConnection conn = new SqlConnection(Settings.Default.NORTHWNDConnectionString);
      SqlCommand cmd = conn.CreateCommand();
      cmd.CommandType = CommandType.Text;
      cmd.CommandText = "SELECT TOP (20) ContactName FROM Customers";
      conn.Open();
      SqlDataReader SqlReader = cmd.ExecuteReader();
      DataSet set = new DataSet();
      set.Tables.Add("Customers");
      set.Load(SqlReader, LoadOption.Upsert, set.Tables[0]);
      conn.Close();
    }

    private void SelectSQLCustomers()
    {
      NorthwindDatabase dataContext = new NorthwindDatabase();

      this.txtOutput.Clear();
      
      var customers = dataContext.Customers.Take(20);
      
      foreach (var customer in customers)
        this.txtOutput.Text += customer.ContactName + "\r\n";    
    }

    #endregion
  }
}
